from itertools import count


# encuentra el menor entero n que cumple 'evaluar (entero) == True'
# si evaluar es falso para 0, 1, 2, ..., n-1
# y verdadero para n, n+1, n+2, ..., inf


def minimo (evaluar, mostrar=False):
	if evaluar (0) == True: return 0
	if evaluar (1) == True: return 1

	# encontrar un numero binario de la forma 100...0
	for ceros in count ():
		nTest = 1 << (ceros + 1)
		if evaluar (nTest) == True: break
		if mostrar: print ('\tsolucion > b{0:b}'.format (1 << ceros))

	# probar encendiendo cada bit, de mayor a menor
	n = 1 << ceros
	for bits in reversed (range (0, ceros)):
		nTest = n ^ (1 << bits)
		if evaluar (nTest) == False:
			n = nTest
			if mostrar: print ('\tsolucion > b{0:b}'.format (n))

	solucion = n + 1
	return solucion


# ----------------------------------------------------------------
if __name__ == '__main__':

	def evaluar (n):
		r = (n ** 2 >= 10)
		return r

	s = minimo (evaluar)

	print ('problema: n^2 >= 10')
	print ('solucion: n = ' + str (s))

