from __calcular_updowns import calcular_updowns
from __composiciones import composiciones
from __todaslaspalabras import todaslaspalabras
from __todaslaspalabras_inicio import todaslaspalabras_inicio


def revisar_valores (grupo, t):
	if (grupo < 1) or (t < 2):
		raise ValueError ('parametros incorrectos')


def constantes (grupo=1, t=4):
		revisar_valores (grupo, t)

		pA = todaslaspalabras_inicio (grupo, t)
		cA = composiciones (pA)
		udA = calcular_updowns (cA)

		pB = todaslaspalabras (grupo, t)
		cB = composiciones (pB)
		udB = calcular_updowns (cB)

		maxdownsA = {N: len (c) - 1 for N, c in cA.items ()}
		maxdownsB = {N: len (c) - 1 for N, c in cB.items ()}

		return udA, udB, maxdownsA, maxdownsB


# ----------------------------------------------------------------
if __name__ == '__main__':

	grupo, t = 2, 4
	udA, udB, mA, mB = constantes (grupo, t)

	print ('udA = ' + repr (udA))
	print ('udB = ' + repr (udB))
	print ('mA = ' + repr (mA))
	print ('mB = ' + repr (mB))

