from itertools import count
from __crear_hashUp import crear_hashUp


def aplicarUps (clave, ups, sal=b'', inicio=False, zetas=None):
	upbits = len (clave[0]) * 8
	hashUp = crear_hashUp (sal, upbits)

	h = b''
	for n, c, u in zip (count (), clave, ups):
		y = zetas[n] - 1 if inicio else u - 1
		h += hashUp (c, iterar=u, x=n, y=y)

	return h


# ----------------------------------------------------------------
if __name__ == '__main__':

	clave = b'abc', b'def', b'ghi', b'jkl'
	ups = 0, 1, 2, 3
	h = aplicarUps (clave, ups)

	print ('clave = ' + str (clave))
	print ('ups = ' + str (ups))
	print ('h = ' + repr (h))

