from fractions import Fraction
from __ceil_raiz import ceil_raiz


def calcular_zetaCheck (bits, maxdownsA, maxdownsB, split):
	peorcaso = 0

	for N, md in maxdownsA.items ():
		f = Fraction (md, N)
		peorcaso = max (peorcaso, f)

	for N, md in maxdownsB.items ():
		f = Fraction (md, N)
		peorcaso = max (peorcaso, f)

	check = peorcaso * (bits + 1)
	zetaCheck = ceil_raiz (check, split) - 1

	return zetaCheck


# ----------------------------------------------------------------
if __name__ == '__main__':

	bits = 128
	mA = {1: 0, 2: 1, 3: 2, 4: 3, 5: 4, 6: 3, 7: 2, 8: 1}
	mB = {2: 0, 3: 1, 4: 2, 5: 5, 6: 4, 7: 3, 8: 3}
	split = 2

	zCheck = calcular_zetaCheck (bits, mA, mB, split)

	print ('zCheck = ' + str (zCheck))

