

def composicion_irrestricta (indice, N=1):
	n = N - 1
	bits = '{0:{n}b}'.format (indice, n=n)
	c = [1]
	for bit in bits:
		if bit == '1':
			c += [1]
		else:
			c[-1] += 1
	return c


# ----------------------------------------------------------------
if __name__ == '__main__':
	import random

	bits = 64

	N = bits + 1
	indice = random.randrange (2 ** bits)
	c = composicion_irrestricta (indice, N)

	print ('N = %s' % N)
	print ('indice = %s' % indice)
	print ('composicion = %s' % str (c))

