from hashlib import sha256, sha512


def hashA (m, bits):
	H = sha512 if bits > 256 else sha256
	mask = (1 << bits) - 1

	h = H (m).hexdigest ()
	h_int = int (h, 16)
	h_int = h_int & mask

	return h_int


# ----------------------------------------------------------------
if __name__ == '__main__':

	bits = 100
	m = b'abc'
	h = hashA (m, bits)

	print ('# m = ' + repr (m))
	print ('# hashA (m) = ' + repr (h))

