from __ceil_raiz import ceil_raiz


def cantidad (a, cantA, b, cantB):
	r = a ** cantA * b ** cantB
	return r


def optimizar_subdivision (letras, espacio):
	base0 = ceil_raiz (espacio, letras)
	base1 = base0 - 1
	cant0 = 0
	cant1 = letras
	while cantidad (base0, cant0, base1, cant1) < espacio:
		cant0 += 1
		cant1 -= 1
	return (base0, cant0), (base1, cant1)


# ----------------------------------------------------------------
if __name__ == '__main__':

	letras = 4
	espacio = 1000

	(a, cA), (b, cB) = optimizar_subdivision (letras, espacio)

	print ('problema:')
	print ('\tletras, espacio = ' + str ((letras, espacio)))
	print ('\tcA + cB = letras')
	print ('\ta ^ cA * b ^ cB >= espacio')
	print ('solucion:')
	print ('\t(a, cA), (b, cB) = ' + str (((a, cA), (b, cB))))

